
/*

	cProcess class definition for the NT::Process module extension

*/
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#include "cIPC.hpp"


class cProcess: public Cipc
{

	private:

	PROCESS_INFORMATION			stProcInfo;
	HANDLE						hProcess;
	HANDLE						hThread;
		
	public:

	BOOL 	bRetVal;
	cProcess( char* szAppName, char* szCommLine,BOOL Inherit,DWORD CreateFlags, char* szCurrDir);
	~cProcess();
	BOOL Kill(UINT uExitCode);
	BOOL Suspend();
	BOOL Resume();
	BOOL GetPriorityClass( DWORD* pdwPriorityClass );
	BOOL SetPriorityClass( DWORD dwPriorityClass );
	BOOL GetExitCode( DWORD* pdwExitCode );

};
