use Cwd;

#globals
#%ops - hash of what to do
$lastdir = getcwd();

sub long2short($) {
	my $currentdir = $_[0];
	my ($shortname, $longname, %map);

	$mydir = getcwd();
	if ($mydir eq $lastdir) {
		print STDERR "doing $mydir twice? chdir failure?\n";
		return;
		}
	$lastdir = $mydir;

    opendir(CWD, $mydir);
	my @files = grep !/^\.\.?$/, readdir CWD;
	closedir(CWD);
	
	push @ops, (".\t$currentdir");
    foreach $longname (@files) {
		$shortname=Win32::GetShortPathName($longname);
		$map{$shortname} = $longname;
		push @ops, ("$shortname\t$longname");
	}

	foreach $longname (@files) {
		if (-d $longname) {
			chdir($longname);
print "changing to $longname directory from $lastdir\n";
			# deal with errors on chdir on entry
			long2short($longname);
		}
	}

    foreach $shortname (sort keys %map) {
##		rename ($map{$shortname},$shortname) || print STDERR "ERROR rename: Could not rename $map{$shortname} to $shortname\n";
print "renaming $map{$shortname} to $shortname\n";
		# xxx deal with errors on rename
	}
	chdir('..') if ($currentdir ne '.');
}

print "here we go...\n";

long2short('.');

print "\... all done!\n";

print @ops;

__END__