
#ifndef ___perl_proto_h___
#define ___perl_proto_h___

#ifdef PERL_OBJECT
void CPerl::Init(void);
#define VIRTUAL virtual
#define NO_STATICS
#else
#define VIRTUAL
#endif

#ifndef NEXT30_NO_ATTRIBUTE
#ifndef HASATTRIBUTE       /* disable GNU-cc attribute checking? */
#ifdef  __attribute__      /* Avoid possible redefinition errors */
#undef  __attribute__
#endif
#define __attribute__(attr)
#endif 
#endif
#ifdef OVERLOAD
VIRTUAL SV*	amagic_call _((SV* left,SV* right,int method,int dir));
VIRTUAL bool Gv_AMupdate _((HV* stash));
#endif /* OVERLOAD */
VIRTUAL OP*	append_elem _((I32 optype, OP* head, OP* tail));
VIRTUAL OP*	append_list _((I32 optype, LISTOP* first, LISTOP* last));
VIRTUAL I32	apply _((I32 type, SV** mark, SV** sp));
VIRTUAL void	assertref _((OP* op));
VIRTUAL void	av_clear _((AV* ar));
VIRTUAL void	av_extend _((AV* ar, I32 key));
VIRTUAL AV*	av_fake _((I32 size, SV** svp));
VIRTUAL SV**	av_fetch _((AV* ar, I32 key, I32 lval));
VIRTUAL void	av_fill _((AV* ar, I32 fill));
VIRTUAL I32	av_len _((AV* ar));
VIRTUAL AV*	av_make _((I32 size, SV** svp));
VIRTUAL SV*	av_pop _((AV* ar));
VIRTUAL void	av_push _((AV* ar, SV* val));
VIRTUAL SV*	av_shift _((AV* ar));
VIRTUAL SV**	av_store _((AV* ar, I32 key, SV* val));
VIRTUAL void	av_undef _((AV* ar));
VIRTUAL void	av_unshift _((AV* ar, I32 num));
VIRTUAL OP*	bind_match _((I32 type, OP* left, OP* pat));
VIRTUAL OP*	block_end _((int line, int floor, OP* seq));
VIRTUAL int	block_start _((void));
VIRTUAL void	boot_core_UNIVERSAL _((void));
VIRTUAL void	calllist _((AV* list));
VIRTUAL I32	cando _((I32 bit, I32 effective, struct stat* statbufp));
#ifndef CASTNEGFLOAT
VIRTUAL U32	cast_ulong _((double f));
#endif
#if !defined(HAS_TRUNCATE) && !defined(HAS_CHSIZE) && defined(F_FREESP)
VIRTUAL I32	my_chsize _((int fd, Off_t length));
#endif
VIRTUAL OP *	ck_gvconst _((OP * o));
VIRTUAL OP *	ck_retarget _((OP *op));
VIRTUAL OP*	convert _((I32 optype, I32 flags, OP* op));
VIRTUAL char*	cpytill _((char* to, char* from, char* fromend, int delim, I32* retlen));
VIRTUAL void	croak _((char* pat,...)) __attribute__((format(printf,1,2),noreturn));
VIRTUAL CV*	cv_clone _((CV* proto));
VIRTUAL void	cv_undef _((CV* cv));
VIRTUAL SV*	cv_const_sv _((CV* cv));
#ifdef DEBUGGING
void	cx_dump _((CONTEXT* cs));
#endif
VIRTUAL SV *	filter_add _((filter_t funcp, SV *datasv));
VIRTUAL void	filter_del _((filter_t funcp));
VIRTUAL I32	filter_read _((int idx, SV *buffer, int maxlen));
VIRTUAL I32	cxinc _((void));
void	deb _((char* pat,...)) __attribute__((format(printf,1,2)));
void	deb_growlevel _((void));
I32	debop _((OP* op));
I32	debstackptrs _((void));
#ifdef DEBUGGING
void	debprofdump _((void));
#endif
I32	debstack _((void));
VIRTUAL void	deprecate _((char* s));
VIRTUAL OP*	die _((char* pat,...)) __attribute__((format(printf,1,2)));
VIRTUAL OP*	die_where _((char* message));
VIRTUAL void	dounwind _((I32 cxix));
VIRTUAL bool	do_aexec _((SV* really, SV** mark, SV** sp));
VIRTUAL void    do_chop _((SV* asv, SV* sv));
VIRTUAL bool	do_close _((GV* gv, bool not_implicit));
VIRTUAL bool	do_eof _((GV* gv));
VIRTUAL bool	do_exec _((char* cmd));
VIRTUAL void	do_execfree _((void));
#if defined(HAS_MSG) || defined(HAS_SEM) || defined(HAS_SHM)
I32	do_ipcctl _((I32 optype, SV** mark, SV** sp));
I32	do_ipcget _((I32 optype, SV** mark, SV** sp));
#endif
VIRTUAL void	do_join _((SV* sv, SV* del, SV** mark, SV** sp));
VIRTUAL OP*	do_kv _((void));
#if defined(HAS_MSG) || defined(HAS_SEM) || defined(HAS_SHM)
I32	do_msgrcv _((SV** mark, SV** sp));
I32	do_msgsnd _((SV** mark, SV** sp));
#endif
VIRTUAL bool	do_open _((GV* gv, char* name, I32 len,
		   int as_raw, int rawmode, int rawperm, PerlIO* supplied_fp));
VIRTUAL void	do_pipe _((SV* sv, GV* rgv, GV* wgv));
VIRTUAL bool	do_print _((SV* sv, PerlIO* fp));
VIRTUAL OP *	do_readline _((void));
VIRTUAL I32	do_chomp _((SV* sv));
VIRTUAL bool	do_seek _((GV* gv, long pos, int whence));
#if defined(HAS_MSG) || defined(HAS_SEM) || defined(HAS_SHM)
I32	do_semop _((SV** mark, SV** sp));
I32	do_shmio _((I32 optype, SV** mark, SV** sp));
#endif
VIRTUAL void	do_sprintf _((SV* sv, I32 len, SV** sarg));
VIRTUAL long	do_tell _((GV* gv));
VIRTUAL I32	do_trans _((SV* sv, OP* arg));
VIRTUAL void	do_vecset _((SV* sv));
VIRTUAL void	do_vop _((I32 optype, SV* sv, SV* left, SV* right));
VIRTUAL I32	dowantarray _((void));
VIRTUAL void	dump_all _((void));
VIRTUAL void	dump_eval _((void));
#ifdef DUMP_FDS  /* See util.c */
int	dump_fds _((char* s));
#endif
void	dump_form _((GV* gv));
void	dump_gv _((GV* gv));
#ifdef MYMALLOC
void	dump_mstats _((char* s));
#endif
void	dump_op _((OP* arg));
void	dump_pm _((PMOP* pm));
void	dump_packsubs _((HV* stash));
void	dump_sub _((GV* gv));
VIRTUAL void	fbm_compile _((SV* sv, I32 iflag));
VIRTUAL char*	fbm_instr _((unsigned char* big, unsigned char* bigend, SV* littlesv));
VIRTUAL OP*	force_list _((OP* arg));
VIRTUAL OP*	fold_constants _((OP * arg));
VIRTUAL void	free_tmps _((void));
VIRTUAL OP*	gen_constant_list _((OP* op));
VIRTUAL void	gp_free _((GV* gv));
VIRTUAL GP*	gp_ref _((GP* gp));
VIRTUAL GV*	gv_AVadd _((GV* gv));
VIRTUAL GV*	gv_HVadd _((GV* gv));
VIRTUAL GV*	gv_IOadd _((GV* gv));
VIRTUAL void	gv_check _((HV* stash));
VIRTUAL void	gv_efullname _((SV* sv, GV* gv));
VIRTUAL void	gv_efullname3 _((SV* sv, GV* gv, char* prefix));
VIRTUAL GV*	gv_fetchfile _((char* name));
VIRTUAL GV*	gv_fetchmeth _((HV* stash, char* name, STRLEN len, I32 level));
VIRTUAL GV*	gv_fetchmethod _((HV* stash, char* name));
VIRTUAL GV*	gv_fetchpv _((char* name, I32 add, I32 sv_type));
VIRTUAL void	gv_fullname _((SV* sv, GV* gv));
VIRTUAL void	gv_fullname3 _((SV* sv, GV* gv, char* prefix));
VIRTUAL void	gv_init _((GV *gv, HV *stash, char *name, STRLEN len, int multi));
VIRTUAL HV*	gv_stashpv _((char* name, I32 create));
VIRTUAL HV*	gv_stashpvn _((char* name, U32 namelen, I32 create));
VIRTUAL HV*	gv_stashsv _((SV* sv, I32 create));
VIRTUAL void	he_delayfree _((HE* hent, I32 shared));
VIRTUAL void	he_free _((HE* hent, I32 shared));
VIRTUAL void	hoistmust _((PMOP* pm));
VIRTUAL void	hv_clear _((HV* tb));
VIRTUAL SV*	hv_delete _((HV* tb, char* key, U32 klen, I32 flags));
VIRTUAL SV*	hv_delete_ent _((HV* tb, SV* key, I32 flags, U32 hash));
VIRTUAL bool	hv_exists _((HV* tb, char* key, U32 klen));
VIRTUAL bool	hv_exists_ent _((HV* tb, SV* key, U32 hash));
VIRTUAL SV**	hv_fetch _((HV* tb, char* key, U32 klen, I32 lval));
VIRTUAL HE*	hv_fetch_ent _((HV* tb, SV* key, I32 lval, U32 hash));
VIRTUAL I32	hv_iterinit _((HV* tb));
VIRTUAL char*	hv_iterkey _((HE* entry, I32* retlen));
VIRTUAL SV*	hv_iterkeysv _((HE* entry));
VIRTUAL HE*	hv_iternext _((HV* tb));
VIRTUAL SV*	hv_iternextsv _((HV* hv, char** key, I32* retlen));
VIRTUAL SV*	hv_iterval _((HV* tb, HE* entry));
VIRTUAL void	hv_ksplit _((HV* hv, IV newmax));
VIRTUAL void	hv_magic _((HV* hv, GV* gv, int how));
VIRTUAL SV**	hv_store _((HV* tb, char* key, U32 klen, SV* val, U32 hash));
VIRTUAL HE*	hv_store_ent _((HV* tb, SV* key, SV* val, U32 hash));
VIRTUAL void	hv_undef _((HV* tb));
VIRTUAL I32	ibcmp _((U8* a, U8* b, I32 len));
VIRTUAL I32	ingroup _((I32 testgid, I32 effective));
VIRTUAL char*	instr _((char* big, char* little));
VIRTUAL bool	io_close _((IO* io));
VIRTUAL OP*	invert _((OP* cmd));
VIRTUAL OP*	jmaybe _((OP* arg));
VIRTUAL I32	keyword _((char* d, I32 len));
VIRTUAL void	leave_scope _((I32 base));
VIRTUAL void	lex_end _((void));
VIRTUAL void	lex_start _((SV *line));
VIRTUAL OP*	linklist _((OP* op));
VIRTUAL OP*	list _((OP* o));
VIRTUAL OP*	listkids _((OP* o));
VIRTUAL OP*	localize _((OP* arg, I32 lexical));
VIRTUAL I32	looks_like_number _((SV* sv));
VIRTUAL int	magic_clearenv	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_clearpack	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_clearsig	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_existspack	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_get	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_getarylen	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_getpack	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_getglob	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_getpos	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_getsig	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_gettaint	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_getuvar	_((SV* sv, MAGIC* mg));
VIRTUAL U32	magic_len	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_nextpack	_((SV* sv, MAGIC* mg, SV* key));
VIRTUAL int	magic_set	_((SV* sv, MAGIC* mg));
#ifdef OVERLOAD
VIRTUAL int	magic_setamagic	_((SV* sv, MAGIC* mg));
#endif /* OVERLOAD */
VIRTUAL int	magic_setarylen	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setbm	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setdbline	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setenv	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setisa	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setglob	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setmglob	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setnkeys	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setpack	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setpos	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setsig	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setsubstr	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_settaint	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setuvar	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_setvec	_((SV* sv, MAGIC* mg));
VIRTUAL int	magic_wipepack	_((SV* sv, MAGIC* mg));
VIRTUAL void	magicname _((char* sym, char* name, I32 namlen));
#ifndef MSWIN32
int	main _((int argc, char** argv, char** env));
#endif
#if !defined(STANDARD_C)
Malloc_t	malloc _((MEM_SIZE nbytes));
#endif
#if defined(MYMALLOC) && defined(HIDEMYMALLOC)
extern Malloc_t malloc _((MEM_SIZE nbytes));
extern Malloc_t realloc _((Malloc_t, MEM_SIZE));
extern Free_t   free _((Malloc_t));
extern Malloc_t calloc _((MEM_SIZE, MEM_SIZE));
#endif
VIRTUAL void	markstack_grow _((void));
VIRTUAL char*	mem_collxfrm _((const char *m, const Size_t n, Size_t * nx));
VIRTUAL char*	mess _((char* pat, va_list* args));
VIRTUAL int	mg_clear _((SV* sv));
VIRTUAL int	mg_copy _((SV *, SV *, char *, I32));
VIRTUAL MAGIC*	mg_find _((SV* sv, int type));
VIRTUAL int	mg_free _((SV* sv));
VIRTUAL int	mg_get _((SV* sv));
VIRTUAL U32	mg_Len _((SV* sv));
VIRTUAL void	mg_magical _((SV* sv));
VIRTUAL int	mg_set _((SV* sv));
VIRTUAL OP*	mod _((OP* op, I32 type));
VIRTUAL char*	moreswitches _((char* s));
VIRTUAL OP *	my _(( OP *));
VIRTUAL char*	my_bcopy _((char* from, char* to, I32 len));
#if !defined(HAS_BZERO) && !defined(HAS_MEMSET)
char*	my_bzero _((char* loc, I32 len));
#endif
VIRTUAL void	my_exit _((U32 status)) __attribute__((noreturn));
VIRTUAL I32	my_lstat _((void));
#ifndef HAS_MEMCMP
I32	my_memcmp _((unsigned char* s1, unsigned char* s2, I32 len));
#endif
VIRTUAL I32	my_pclose _((PerlIO* ptr));
VIRTUAL PerlIO*	my_popen _((char* cmd, char* mode));
VIRTUAL void	my_setenv _((char* nam, char* val));
VIRTUAL I32	my_stat _((void));
#ifdef MYSWAP
VIRTUAL short	my_swap _((short s));
VIRTUAL long	my_htonl _((long l));
VIRTUAL long	my_ntohl _((long l));
#endif
VIRTUAL void	my_unexec _((void));
VIRTUAL OP*	newANONLIST _((OP* op));
VIRTUAL OP*	newANONHASH _((OP* op));
VIRTUAL OP*	newANONSUB _((I32 floor, OP* proto, OP* block));
VIRTUAL OP*	newASSIGNOP _((I32 flags, OP* left, I32 optype, OP* right));
VIRTUAL OP*	newCONDOP _((I32 flags, OP* expr, OP* trueop, OP* falseop));
VIRTUAL void	newFORM _((I32 floor, OP* op, OP* block));
VIRTUAL OP*	newFOROP _((I32 flags, char* label, line_t forline, OP* scalar, OP* expr, OP*block, OP*cont));
VIRTUAL OP*	newLOGOP _((I32 optype, I32 flags, OP* left, OP* right));
VIRTUAL OP*	newLOOPEX _((I32 type, OP* label));
VIRTUAL OP*	newLOOPOP _((I32 flags, I32 debuggable, OP* expr, OP* block));
VIRTUAL OP*	newNULLLIST _((void));
VIRTUAL OP*	newOP _((I32 optype, I32 flags));
VIRTUAL void	newPROG _((OP* op));
VIRTUAL OP*	newRANGE _((I32 flags, OP* left, OP* right));
VIRTUAL OP*	newSLICEOP _((I32 flags, OP* subscript, OP* list));
VIRTUAL OP*	newSTATEOP _((I32 flags, char* label, OP* o));
VIRTUAL CV*	newSUB _((I32 floor, OP* op, OP* proto, OP* block));
VIRTUAL CV*	newXS _((char *name, void (*subaddr)(CPERLarg_ CV* cv), char *filename));
#ifdef DEPRECATED
CV*	newXSUB _((char *name, I32 ix, I32 (*subaddr)(int,int,int), char *filename));
#endif
VIRTUAL AV*	newAV _((void));
VIRTUAL OP*	newAVREF _((OP* o));
VIRTUAL OP*	newBINOP _((I32 type, I32 flags, OP* first, OP* last));
VIRTUAL OP*	newCVREF _((I32 flags, OP* o));
VIRTUAL OP*	newGVOP _((I32 type, I32 flags, GV* gv));
VIRTUAL GV*	newGVgen _((char *pack));
VIRTUAL OP*	newGVREF _((I32 type, OP* o));
VIRTUAL OP*	newHVREF _((OP* o));
VIRTUAL HV*	newHV _((void));
VIRTUAL IO*	newIO _((void));
VIRTUAL OP*	newLISTOP _((I32 type, I32 flags, OP* first, OP* last));
VIRTUAL OP*	newPMOP _((I32 type, I32 flags));
VIRTUAL OP*	newPVOP _((I32 type, I32 flags, char* pv));
VIRTUAL SV*	newRV _((SV* ref));
#ifdef LEAKTEST
VIRTUAL SV*	newSV _((I32 x, STRLEN len));
#else
VIRTUAL SV*	newSV _((STRLEN len));
#endif
VIRTUAL OP*	newSVREF _((OP* o));
VIRTUAL OP*	newSVOP _((I32 type, I32 flags, SV* sv));
VIRTUAL SV*	newSViv _((IV i));
VIRTUAL SV*	newSVnv _((double n));
VIRTUAL SV*	newSVpv _((char* s, STRLEN len));
VIRTUAL SV*	newSVrv _((SV* rv, char* classname));
VIRTUAL SV*	newSVsv _((SV* old));
VIRTUAL OP*	newUNOP _((I32 type, I32 flags, OP* first));
VIRTUAL OP *	newWHILEOP _((I32 flags, I32 debuggable, LOOP* loop, OP* expr, OP* block, OP* cont));
VIRTUAL PerlIO*	nextargv _((GV* gv));
VIRTUAL char*	ninstr _((char* big, char* bigend, char* little, char* lend));

#ifdef MSWIN32
#ifndef u_long
typedef unsigned long   u_long;
#endif
#ifndef u_short
typedef unsigned short  u_short;
typedef unsigned int    u_int;
#endif
#ifndef SOCKET
typedef u_int           SOCKET;
#endif

virtual u_long nt_htonl _((u_long hostlong));
virtual u_short nt_htons _((u_short hostshort));
virtual u_long nt_ntohl _((u_long netlong));
virtual u_short nt_ntohs _((u_short netshort));
virtual SOCKET nt_accept _((SOCKET s, struct sockaddr *addr, int *addrlen));
virtual int nt_bind _((SOCKET s, struct sockaddr *addr, int addrlen));
virtual int nt_connect _((SOCKET s, struct sockaddr *addr, int addrlen));
virtual int nt_getpeername _((SOCKET s, struct sockaddr *addr, int *addrlen));
virtual int nt_getsockname _((SOCKET s, struct sockaddr *addr, int *addrlen));
virtual int nt_getsockopt _((SOCKET s, int level, int optname, char *optval, int *optlen));
virtual int nt_ioctlsocket _((SOCKET s, long cmd, u_long *argp));
virtual int nt_listen _((SOCKET s, int backlog));
virtual int nt_recv _((SOCKET s, char *buf, int len, int flags));
virtual int nt_recvfrom _((SOCKET s, char *buf, int len, int flags, struct sockaddr *from, int *fromlen));
virtual long nt_select _((int nfds, int* rd, int* wr, int* ex, struct timeval* timeout));
virtual int nt_send _((SOCKET s, char *buf, int len, int flags));
virtual int nt_sendto _((SOCKET s, char *buf, int len, int flags, struct sockaddr *to, int tolen));
virtual int nt_setsockopt _((SOCKET s, int level, int optname, char *optval, int optlen));
virtual int nt_shutdown _((SOCKET s, int how));
virtual SOCKET nt_socket _((int af, int type, int protocol));
virtual struct hostent *nt_gethostbyaddr _((char *addr, int len, int type));
virtual struct hostent *nt_gethostbyname _((char *name));
virtual int nt_gethostname _((char *name, int len));
virtual struct protoent *nt_getprotobyname _((char *name));
virtual struct protoent *nt_getprotobynumber _((int num));
virtual struct servent *nt_getservbyname _((char *name, char *proto));
virtual struct servent *nt_getservbyport _((int port, char *proto));
virtual void endhostent _((void)); 
virtual void endnetent _((void));
virtual void endprotoent _((void));
virtual void endservent _((void));
virtual struct netent *getnetent _((void)); 
virtual struct netent *getnetbyname _((char *name)); 
virtual struct netent *getnetbyaddr _((long net, int type)); 
virtual struct protoent *getprotoent _((void)); 
virtual struct servent *getservent _((void)); 
virtual void sethostent _((int stayopen));
virtual void setnetent _((int stayopen));
virtual void setprotoent _((int stayopen));
virtual void setservent _((int stayopen));
#endif

VIRTUAL OP *	oopsCV _((OP* o));
VIRTUAL void	op_free _((OP* arg));
VIRTUAL void	package _((OP* op));
VIRTUAL PADOFFSET	pad_alloc _((I32 optype, U32 tmptype));
VIRTUAL PADOFFSET	pad_allocmy _((char* name));
VIRTUAL PADOFFSET	pad_findmy _((char* name));
VIRTUAL OP*	oopsAV _((OP* o));
VIRTUAL OP*	oopsHV _((OP* o));
VIRTUAL void	pad_leavemy _((I32 fill));
VIRTUAL SV*	pad_sv _((PADOFFSET po));
VIRTUAL void	pad_free _((PADOFFSET po));
VIRTUAL void	pad_reset _((void));
VIRTUAL void	pad_swipe _((PADOFFSET po));
VIRTUAL void	peep _((OP* op));
#ifndef PERL_OBJECT
VIRTUAL PerlInterpreter*	perl_alloc _((void));
#else
static CPerl*	perl_alloc _((IPerlSupport *pvtbl));
#endif
VIRTUAL I32	perl_call_argv _((char* subname, I32 flags, char** argv));
VIRTUAL I32	perl_call_method _((char* methname, I32 flags));
VIRTUAL I32	perl_call_pv _((char* subname, I32 flags));
VIRTUAL I32	perl_call_sv _((SV* sv, I32 flags));
#ifndef PERL_OBJECT
VIRTUAL void	perl_construct _((PerlInterpreter* sv_interp));
VIRTUAL void	perl_destruct _((PerlInterpreter* sv_interp));
#else
virtual void	perl_construct _((void));
virtual void	perl_destruct _((void));
#endif
VIRTUAL I32	perl_eval_sv _((SV* sv, I32 flags));
#ifndef PERL_OBJECT
void	perl_free _((PerlInterpreter* sv_interp));
#else
virtual void	perl_free _((void));
#endif
VIRTUAL SV*	perl_get_sv _((char* name, I32 create));
VIRTUAL AV*	perl_get_av _((char* name, I32 create));
VIRTUAL HV*	perl_get_hv _((char* name, I32 create));
VIRTUAL CV*	perl_get_cv _((char* name, I32 create));
VIRTUAL int	perl_init_fold _(());
VIRTUAL int	perl_init_i18nl10n _((int printwarn));
#ifndef PERL_OBJECT
VIRTUAL int	perl_parse _((PerlInterpreter* sv_interp, void(*xsinit)(void), int argc, char** argv, char** env));
#else
virtual int	perl_parse _((void(*xsinit)(CPerl*), int argc, char** argv, char** env));
#endif
VIRTUAL void	perl_require_pv _((char* pv));
#define perl_requirepv perl_require_pv
#ifndef PERL_OBJECT
VIRTUAL int	perl_run _((PerlInterpreter* sv_interp));
#else
virtual int	perl_run _((void));
#endif
VIRTUAL void	pidgone _((int pid, int status));
VIRTUAL void	pmflag _((U16* pmfl, int ch));
VIRTUAL OP*	pmruntime _((OP* pm, OP* expr, OP* repl));
VIRTUAL OP*	pmtrans _((OP* op, OP* expr, OP* repl));
VIRTUAL OP*	pop_return _((void));
VIRTUAL void	pop_scope _((void));
VIRTUAL OP*	prepend_elem _((I32 optype, OP* head, OP* tail));
VIRTUAL void	provide_ref _((OP* op, SV* sv));
VIRTUAL void	push_return _((OP* op));
VIRTUAL void	push_scope _((void));
VIRTUAL regexp*	pregcomp _((char* exp, char* xend, PMOP* pm));
VIRTUAL OP*	ref _((OP* op, I32 type));
VIRTUAL OP*	refkids _((OP* op, I32 type));
#ifdef DEBUGGING
void	regdump _((regexp* r));
#endif
VIRTUAL I32	pregexec _((regexp* prog, char* stringarg, char* strend, char* strbeg, I32 minend, SV* screamer, I32 safebase));
VIRTUAL void	pregfree _((struct regexp* r));
VIRTUAL char*	regnext _((char* p));
#ifdef DEBUGGING
char*	regprop _((char* op));
#endif
VIRTUAL void	repeatcpy _((char* to, char* from, I32 len, I32 count));
VIRTUAL char*	rninstr _((char* big, char* bigend, char* little, char* lend));
VIRTUAL int	runops _((void));
#ifndef safemalloc
VIRTUAL void	safefree _((Malloc_t where));
VIRTUAL Malloc_t	safemalloc _((MEM_SIZE size));
#ifndef MSDOS
VIRTUAL Malloc_t	saferealloc _((Malloc_t where, MEM_SIZE size));
#else
VIRTUAL Malloc_t	saferealloc _((Malloc_t where, unsigned long size));
#endif
VIRTUAL Malloc_t	safecalloc _((MEM_SIZE cnt, MEM_SIZE size));
#endif
#ifdef LEAKTEST
VIRTUAL void	safexfree _((Malloc_t where));
VIRTUAL Malloc_t	safexmalloc _((I32 x, MEM_SIZE size));
VIRTUAL Malloc_t	safexrealloc _((Malloc_t where, MEM_SIZE size));
VIRTUAL Malloc_t	safexcalloc _((I32 x, MEM_SIZE size, MEM_SIZE size));
#endif
#ifndef HAS_RENAME
I32	same_dirent _((char* a, char* b));
#endif
VIRTUAL char*	savepv _((char* sv));
VIRTUAL char*	savepvn _((char* sv, I32 len));
VIRTUAL char*	sharepvn _((char* sv, I32 len, U32 hash));
VIRTUAL void	unsharepvn _((char* sv, I32 len, U32 hash));
VIRTUAL void	savestack_grow _((void));
VIRTUAL void	save_aptr _((AV** aptr));
VIRTUAL AV*	save_ary _((GV* gv));
VIRTUAL void	save_clearsv _((SV** svp));
VIRTUAL void	save_delete _((HV* hv, char* key, I32 klen));
#ifndef titan  /* TitanOS cc can't handle this */
#ifndef PERL_OBJECT
void	save_destructor _((void (*f)(void*), void* p));
#else
void	save_destructor _((void (*f)(void*,void*), void* p));
#endif
#endif /* titan */
VIRTUAL void	save_freesv _((SV* sv));
VIRTUAL void	save_freeop _((OP* op));
VIRTUAL void	save_freepv _((char* pv));
VIRTUAL HV*	save_hash _((GV* gv));
VIRTUAL void	save_hptr _((HV** hptr));
VIRTUAL void	save_I32 _((I32* intp));
VIRTUAL void	save_int _((int* intp));
VIRTUAL void	save_item _((SV* item));
VIRTUAL void	save_list _((SV** sarg, I32 maxsarg));
VIRTUAL void	save_long _((long *longp));
VIRTUAL void	save_nogv _((GV* gv));
VIRTUAL SV*	save_scalar _((GV* gv));
VIRTUAL void	save_pptr _((char **pptr));
VIRTUAL void	save_sptr _((SV** sptr));
VIRTUAL SV*	save_svref _((SV** sptr));
VIRTUAL OP*	sawparens _((OP* o));
VIRTUAL OP*	scalar _((OP* o));
VIRTUAL OP*	scalarkids _((OP* op));
VIRTUAL OP*	scalarseq _((OP* o));
VIRTUAL OP*	scalarvoid _((OP* op));
VIRTUAL unsigned long	scan_hex _((char* start, I32 len, I32* retlen));
VIRTUAL char*	scan_num _((char* s));
VIRTUAL unsigned long	scan_oct _((char* start, I32 len, I32* retlen));
VIRTUAL OP*	scope _((OP* o));
VIRTUAL char*	screaminstr _((SV* bigsv, SV* littlesv));
#ifndef VMS
I32	setenv_getix _((char* nam));
#endif
VIRTUAL void	setdefout _((GV *gv));
VIRTUAL Signal_t sighandler _((int sig));
VIRTUAL SV**	stack_grow _((SV** sp, SV**p, int n));
VIRTUAL int	start_subparse _((void));
VIRTUAL bool	sv_2bool _((SV* sv));
VIRTUAL CV*	sv_2cv _((SV* sv, HV** st, GV** gvp, I32 lref));
VIRTUAL IO*	sv_2io _((SV* sv));
VIRTUAL IV	sv_2iv _((SV* sv));
VIRTUAL SV*	sv_2mortal _((SV* sv));
VIRTUAL double	sv_2nv _((SV* sv));
VIRTUAL char*	sv_2pv _((SV* sv, STRLEN* lp));
VIRTUAL void	sv_add_arena _((char* ptr, U32 size, U32 flags));
VIRTUAL int	sv_backoff _((SV* sv));
VIRTUAL SV*	sv_bless _((SV* sv, HV* stash));
VIRTUAL void	sv_catpv _((SV* sv, char* ptr));
VIRTUAL void	sv_catpvn _((SV* sv, char* ptr, STRLEN len));
VIRTUAL void	sv_catsv _((SV* dsv, SV* ssv));
VIRTUAL void	sv_chop _((SV* sv, char* ptr));
VIRTUAL void	sv_clean_all _((void));
VIRTUAL void	sv_clean_objs _((void));
VIRTUAL void	sv_clear _((SV* sv));
VIRTUAL I32	sv_cmp _((SV* sv1, SV* sv2));
VIRTUAL void	sv_dec _((SV* sv));
VIRTUAL void	sv_dump _((SV* sv));
VIRTUAL I32	sv_eq _((SV* sv1, SV* sv2));
VIRTUAL void	sv_free _((SV* sv));
VIRTUAL void	sv_free_arenas _((void));
VIRTUAL char*	sv_gets _((SV* sv, PerlIO* fp, I32 append));
#ifndef DOSISH
VIRTUAL char*	sv_grow _((SV* sv, I32 newlen));
#else
VIRTUAL char*	sv_grow _((SV* sv, unsigned long newlen));
#endif
VIRTUAL void	sv_inc _((SV* sv));
VIRTUAL void	sv_insert _((SV* bigsv, STRLEN offset, STRLEN len, char* little, STRLEN littlelen));
VIRTUAL int	sv_isa _((SV* sv, char* name));
VIRTUAL int	sv_isobject _((SV* sv));
VIRTUAL STRLEN	sv_len _((SV* sv));
VIRTUAL void	sv_magic _((SV* sv, SV* obj, int how, char* name, I32 namlen));
VIRTUAL SV*	sv_mortalcopy _((SV* oldsv));
VIRTUAL SV*	sv_newmortal _((void));
VIRTUAL SV*	sv_newref _((SV* sv));
#ifdef DEBUGGING
char *	sv_peek _((SV* sv));
#endif
VIRTUAL char *	sv_pvn_force _((SV* sv, STRLEN* lp));
VIRTUAL char*	sv_reftype _((SV* sv, int ob));
VIRTUAL void	sv_replace _((SV* sv, SV* nsv));
VIRTUAL void	sv_report_used _((void));
VIRTUAL void	sv_reset _((char* s, HV* stash));
VIRTUAL void	sv_setiv _((SV* sv, IV num));
VIRTUAL void	sv_setnv _((SV* sv, double num));
VIRTUAL SV*	sv_setref_iv _((SV *rv, char *classname, IV iv));
VIRTUAL SV*	sv_setref_nv _((SV *rv, char *classname, double nv));
VIRTUAL SV*	sv_setref_pv _((SV *rv, char *classname, void* pv));
VIRTUAL SV*	sv_setref_pvn _((SV *rv, char *classname, char* pv, I32 n));
VIRTUAL void	sv_setpv _((SV* sv, char* ptr));
VIRTUAL void	sv_setpvn _((SV* sv, char* ptr, STRLEN len));
VIRTUAL void	sv_setsv _((SV* dsv, SV* ssv));
VIRTUAL int	sv_unmagic _((SV* sv, int type));
VIRTUAL void	sv_unref _((SV* sv));
VIRTUAL bool	sv_upgrade _((SV* sv, U32 mt));
VIRTUAL void	sv_usepvn _((SV* sv, char* ptr, STRLEN len));
VIRTUAL void	taint_env _((void));
VIRTUAL void	taint_not _((char *s));
VIRTUAL void	taint_proper _((char* f, char* s));
#ifdef UNLINK_ALL_VERSIONS
I32	unlnk _((char* f));
#endif
VIRTUAL void	utilize _((int aver, I32 floor, OP *version, OP* id, OP* arg));
I32	wait4pid _((int pid, int* statusp, int flags));
VIRTUAL void	warn _((char* pat,...)) __attribute__((format(printf,1,2)));
VIRTUAL void	watch _((char **addr));
VIRTUAL I32	whichsig _((char* sig));
VIRTUAL int	yyerror _((char* s));
VIRTUAL int	yylex _((void));
VIRTUAL int	yyparse _((void));
VIRTUAL int	yywarn _((char* s));

#ifdef PERL_OBJECT
protected:
#endif

#ifdef NO_STATICS
SV *more_sv _((void));
XPVIV *more_xiv _((void));
XPVNV *more_xnv _((void));
XPV *more_xpv _((void));
XRV *more_xrv _((void));
SV *new_sv _((void));
XPVIV *new_xiv _((void));
XPVNV *new_xnv _((void));
XPV *new_xpv _((void));
XRV *new_xrv _((void));
void del_xiv _((XPVIV* p));
void del_xnv _((XPVNV* p));
void del_xpv _((XPV* p));
void del_xrv _((XRV* p));
void sv_mortalgrow _((void));
typedef void (CPerl::*SVFUNC) _((SV*));
void visit _((SVFUNC f));
void do_report_used _((SV* sv));
void do_clean_named_objs _((SV* sv));
void do_clean_objs _((SV* sv));
void do_clean_all _((SV* sv));

void sv_unglob _((SV* sv));

I32 regmatch _((char *prog));
I32 regrepeat _((char *p, I32 max));
I32 regtry _((regexp *prog, char *startpos));

typedef struct magic_state MGS;

MGS *save_magic _((SV* sv));
int magic_methpack _((SV* sv, MAGIC* mg, char *meth));

char *Reg _((I32, I32 *));
char *reganode _((char, unsigned short));
char *regatom _((I32 *));
char *regbranch _((I32 *));
void regc _((char));
char *regclass _((void));
I32 regcurly _((char *));
char *regnode _((char));
char *regpiece _((I32 *));
void reginsert _((char, char *));
void regoptail _((char *, char *));
void regset _((char *, I32, I32));
void regtail _((char *, char *));
char* nextchar _((void));
void debprof _((OP*op));
void check_uni _((void));
void  force_next _((I32 type));
char *force_word _((char *start, int token, int check_keyword, int allow_pack, int allow_tick));
SV *tokeQ _((SV *sv));
char *scan_const _((char *start));
char *scan_formline _((char *s));
char *scan_heredoc _((char *s));
char *scan_ident _((char *s, char *send, char *dest, I32 ck_uni));
char *scan_inputsymbol _((char *start));
char *scan_pat _((char *start));
char *scan_str _((char *start));
char *scan_subst _((char *start));
char *scan_trans _((char *start));
char *scan_word _((char *s, char *dest, int allow_package, STRLEN *slp));
char *skipspace _((char *s));
void checkcomma _((char *s, char *name, char *what));
void force_ident _((char *s, int kind));
char *force_version _((char *s));
void incline _((char *s));
int intuit_method _((char *s, GV *gv));
int intuit_more _((char *s));
I32 lop _((I32 f, expectation x, char *s));
void missingterm _((char *s));
void no_op _((char *what, char *s));
void set_csh _((void));
I32 sublex_done _((void));
I32 sublex_start _((void));
char * filter_gets _((SV *sv, PerlIO *fp, STRLEN append));
OP * doform _((CV *cv, GV *gv, OP *retop));
char* incl_perldb _((void));
void save_iv _((IV *ivp));
void find_beginning _((void));
void incpush _((char *));
void init_ids _((void));
void init_debugger _((void));
void init_lexer _((void));
void init_main_stash _((void));
void init_perllib _((void));
void init_postdump_symbols _((int, char **, char **));
void init_predump_symbols _((void));
void init_stacks _((void));
void nuke_stacks _((void));
void open_script _((char *, bool, SV *));
void validate_suid _((char *, char *));
I32 list_assignment _((OP *op));
OP *bad_type _((I32 n, char *t, char *name, OP *kid));
OP *modkids _((OP *op, I32 type));
OP *no_fh_allowed _((OP *op));
OP *scalarboolean _((OP *op));
OP *too_few_arguments _((OP *op, char* name));
OP *too_many_arguments _((OP *op, char* name));
void null _((OP* op));
PADOFFSET pad_findlex _((char* name, PADOFFSET newoff, I32 seq, CV* startcv, I32 cx_ix));
void gv_init_sv _((GV* gv,I32 sv_type));
void doencodes _((SV *sv, char *s, I32 len));
void hsplit _((HV *hv));
void hfreeentries _((HV *hv));
OP *doeval _((int gimme));
OP *dofindlabel _((OP *op, char *label, OP **opstack));
void doparseform _((SV *sv));
I32 dopoptoeval _((I32 startingblock));
I32 dopoptolabel _((char *label));
I32 dopoptoloop _((I32 startingblock));
I32 dopoptosub _((I32 startingblock));
void save_lines _((AV *array, SV *sv));
public:
int sortcmp _((const void *, const void *));
int sortcv _((const void *, const void *));
void restore_magic _((void *p));
void restore_rsfp _((void *f));
void yydestruct _((void* ptr));
protected:
HE* more_he _((void));
HE* new_he _((void));
void del_he _((HE* p));
char* CvNAME _((CV* cv));
void dump _((char *arg1, ...));
int ao _((int toketype));

#define DEFSTATIC

#else /* NO_STATICS */
#define DEFSTATIC static
#endif  /* NO_STATICS */

#ifdef PERL_OBJECT
#ifdef DEBUGGING
void del_sv(SV* p);
#endif

virtual void not_a_number _((SV *sv));
virtual void av_reify _((AV* av));

typedef I32 CHECKPOINT;

virtual CHECKPOINT regcppush _((I32 parenfloor));
virtual char * regcppop _((void));

/* end of protected */

public:

virtual OP*	ck_concat _((OP *op));
virtual OP*	ck_delete _((OP *op));
virtual OP*	ck_eof _((OP *op));
virtual OP*	ck_eval _((OP *op));
virtual OP*	ck_exec _((OP *op));
virtual OP*	ck_formline _((OP *op));
virtual OP*	ck_ftst _((OP *op));
virtual OP*	ck_fun _((OP *op));
virtual OP*	ck_glob _((OP *op));
virtual OP*	ck_grep _((OP *op));
virtual OP*	ck_index _((OP *op));
virtual OP*	ck_lengthconst _((OP *op));
virtual OP*	ck_lfun _((OP *op));
virtual OP*	ck_listiob _((OP *op));
virtual OP*	ck_match _((OP *op));
virtual OP*	ck_null _((OP *op));
virtual OP*	ck_repeat _((OP *op));
virtual OP*	ck_require _((OP *op));
virtual OP*	ck_rfun _((OP *op));
virtual OP*	ck_rvconst _((OP *op));
virtual OP*	ck_select _((OP *op));
virtual OP*	ck_shift _((OP *op));
virtual OP*	ck_sort _((OP *op));
virtual OP*	ck_spair _((OP *op));
virtual OP*	ck_split _((OP *op));
virtual OP*	ck_subr _((OP *op));
virtual OP*	ck_svconst _((OP *op));
virtual OP*	ck_trunc _((OP *op));

#define ARGSproto void
#define PP(s) OP* CPERLscope(s _((ARGSproto)))

PP(pp_aassign);
PP(pp_abs);
PP(pp_accept);
PP(pp_add);
PP(pp_aelem);
PP(pp_aelemfast);
PP(pp_alarm);
PP(pp_and);
PP(pp_andassign);
PP(pp_anoncode);
PP(pp_anonhash);
PP(pp_anonlist);
PP(pp_aslice);
PP(pp_atan2);
PP(pp_av2arylen);
PP(pp_backtick);
PP(pp_bind);
PP(pp_binmode);
PP(pp_bit_and);
PP(pp_bit_or);
PP(pp_bit_xor);
PP(pp_bless);
PP(pp_caller);
PP(pp_chdir);
PP(pp_chmod);
PP(pp_chomp);
PP(pp_chop);
PP(pp_chown);
PP(pp_chr);
PP(pp_chroot);
PP(pp_close);
PP(pp_closedir);
PP(pp_complement);
PP(pp_concat);
PP(pp_cond_expr);
PP(pp_connect);
PP(pp_const);
PP(pp_cos);
PP(pp_crypt);
PP(pp_cswitch);
PP(pp_dbmclose);
PP(pp_dbmopen);
PP(pp_dbstate);
PP(pp_defined);
PP(pp_delete);
PP(pp_die);
PP(pp_divide);
PP(pp_dofile);
PP(pp_dump);
PP(pp_each);
PP(pp_egrent);
PP(pp_ehostent);
PP(pp_enetent);
PP(pp_enter);
PP(pp_entereval);
PP(pp_enteriter);
PP(pp_enterloop);
PP(pp_entersub);
PP(pp_entersubr);
PP(pp_entertry);
PP(pp_enterwrite);
PP(pp_eof);
PP(pp_eprotoent);
PP(pp_epwent);
PP(pp_eq);
PP(pp_eservent);
PP(pp_exec);
PP(pp_exists);
PP(pp_exit);
PP(pp_exp);
PP(pp_fcntl);
PP(pp_fileno);
PP(pp_flip);
PP(pp_flock);
PP(pp_flop);
PP(pp_fork);
PP(pp_formline);
PP(pp_ftatime);
PP(pp_ftbinary);
PP(pp_ftblk);
PP(pp_ftchr);
PP(pp_ftctime);
PP(pp_ftdir);
PP(pp_fteexec);
PP(pp_fteowned);
PP(pp_fteread);
PP(pp_ftewrite);
PP(pp_ftfile);
PP(pp_ftis);
PP(pp_ftlink);
PP(pp_ftmtime);
PP(pp_ftpipe);
PP(pp_ftrexec);
PP(pp_ftrowned);
PP(pp_ftrread);
PP(pp_ftrwrite);
PP(pp_ftsgid);
PP(pp_ftsize);
PP(pp_ftsock);
PP(pp_ftsuid);
PP(pp_ftsvtx);
PP(pp_fttext);
PP(pp_fttty);
PP(pp_ftzero);
PP(pp_ge);
PP(pp_gelem);
PP(pp_getc);
PP(pp_getlogin);
PP(pp_getpeername);
PP(pp_getpgrp);
PP(pp_getppid);
PP(pp_getpriority);
PP(pp_getsockname);
PP(pp_ggrent);
PP(pp_ggrgid);
PP(pp_ggrnam);
PP(pp_ghbyaddr);
PP(pp_ghbyname);
PP(pp_ghostent);
PP(pp_glob);
PP(pp_gmtime);
PP(pp_gnbyaddr);
PP(pp_gnbyname);
PP(pp_gnetent);
PP(pp_goto);
PP(pp_gpbyname);
PP(pp_gpbynumber);
PP(pp_gprotoent);
PP(pp_gpwent);
PP(pp_gpwnam);
PP(pp_gpwuid);
PP(pp_grepstart);
PP(pp_grepwhile);
PP(pp_gsbyname);
PP(pp_gsbyport);
PP(pp_gservent);
PP(pp_gsockopt);
PP(pp_gt);
PP(pp_gv);
PP(pp_gvsv);
PP(pp_helem);
PP(pp_hex);
PP(pp_hslice);
PP(pp_i_add);
PP(pp_i_divide);
PP(pp_i_eq);
PP(pp_i_ge);
PP(pp_i_gt);
PP(pp_i_le);
PP(pp_i_lt);
PP(pp_i_modulo);
PP(pp_i_multiply);
PP(pp_i_ncmp);
PP(pp_i_ne);
PP(pp_i_negate);
PP(pp_i_subtract);
PP(pp_index);
PP(pp_indread);
PP(pp_int);
PP(pp_ioctl);
PP(pp_iter);
PP(pp_join);
PP(pp_keys);
PP(pp_kill);
PP(pp_last);
PP(pp_lc);
PP(pp_lcfirst);
PP(pp_le);
PP(pp_leave);
PP(pp_leaveeval);
PP(pp_leaveloop);
PP(pp_leavesub);
PP(pp_leavetry);
PP(pp_leavewrite);
PP(pp_left_shift);
PP(pp_length);
PP(pp_lineseq);
PP(pp_link);
PP(pp_list);
PP(pp_listen);
PP(pp_localtime);
PP(pp_log);
PP(pp_lslice);
PP(pp_lstat);
PP(pp_lt);
PP(pp_mapstart);
PP(pp_mapwhile);
PP(pp_match);
PP(pp_method);
PP(pp_mkdir);
PP(pp_modulo);
PP(pp_msgctl);
PP(pp_msgget);
PP(pp_msgrcv);
PP(pp_msgsnd);
PP(pp_multiply);
PP(pp_ncmp);
PP(pp_ne);
PP(pp_negate);
PP(pp_next);
PP(pp_nextstate);
PP(pp_not);
PP(pp_nswitch);
PP(pp_null);
PP(pp_oct);
PP(pp_open);
PP(pp_open_dir);
PP(pp_or);
PP(pp_orassign);
PP(pp_ord);
PP(pp_pack);
PP(pp_padany);
PP(pp_padav);
PP(pp_padhv);
PP(pp_padsv);
PP(pp_pipe_op);
PP(pp_pop);
PP(pp_pos);
PP(pp_postdec);
PP(pp_postinc);
PP(pp_pow);
PP(pp_predec);
PP(pp_preinc);
PP(pp_print);
PP(pp_prototype);
PP(pp_prtf);
PP(pp_push);
PP(pp_pushmark);
PP(pp_pushre);
PP(pp_quotemeta);
PP(pp_rand);
PP(pp_range);
PP(pp_rcatline);
PP(pp_read);
PP(pp_readdir);
PP(pp_readline);
PP(pp_readlink);
PP(pp_recv);
PP(pp_redo);
PP(pp_ref);
PP(pp_refgen);
PP(pp_regcmaybe);
PP(pp_regcomp);
PP(pp_rename);
PP(pp_repeat);
PP(pp_require);
PP(pp_reset);
PP(pp_return);
PP(pp_reverse);
PP(pp_rewinddir);
PP(pp_right_shift);
PP(pp_rindex);
PP(pp_rmdir);
PP(pp_rv2av);
PP(pp_rv2cv);
PP(pp_rv2gv);
PP(pp_rv2hv);
PP(pp_rv2sv);
PP(pp_sassign);
PP(pp_scalar);
PP(pp_schomp);
PP(pp_schop);
PP(pp_scmp);
PP(pp_scope);
PP(pp_seek);
PP(pp_seekdir);
PP(pp_select);
PP(pp_semctl);
PP(pp_semget);
PP(pp_semop);
PP(pp_send);
PP(pp_seq);
PP(pp_setpgrp);
PP(pp_setpriority);
PP(pp_sge);
PP(pp_sgrent);
PP(pp_sgt);
PP(pp_shift);
PP(pp_shmctl);
PP(pp_shmget);
PP(pp_shmread);
PP(pp_shmwrite);
PP(pp_shostent);
PP(pp_shutdown);
PP(pp_sin);
PP(pp_sle);
PP(pp_sleep);
PP(pp_slt);
PP(pp_sne);
PP(pp_snetent);
PP(pp_socket);
PP(pp_sockpair);
PP(pp_sort);
PP(pp_splice);
PP(pp_split);
PP(pp_sprintf);
PP(pp_sprotoent);
PP(pp_spwent);
PP(pp_sqrt);
PP(pp_srand);
PP(pp_srefgen);
PP(pp_sselect);
PP(pp_sservent);
PP(pp_ssockopt);
PP(pp_stat);
PP(pp_stringify);
PP(pp_stub);
PP(pp_study);
PP(pp_subst);
PP(pp_substcont);
PP(pp_substr);
PP(pp_subtract);
PP(pp_symlink);
PP(pp_syscall);
PP(pp_sysopen);
PP(pp_sysread);
PP(pp_system);
PP(pp_syswrite);
PP(pp_tell);
PP(pp_telldir);
PP(pp_tie);
PP(pp_tied);
PP(pp_time);
PP(pp_tms);
PP(pp_trans);
PP(pp_truncate);
PP(pp_uc);
PP(pp_ucfirst);
PP(pp_umask);
PP(pp_undef);
PP(pp_unlink);
PP(pp_unpack);
PP(pp_unshift);
PP(pp_unstack);
PP(pp_untie);
PP(pp_utime);
PP(pp_values);
PP(pp_vec);
PP(pp_wait);
PP(pp_waitpid);
PP(pp_wantarray);
PP(pp_warn);
PP(pp_xor);

#ifndef MSWIN32
CPerl();
#else
virtual int	do_aspawn _((void* really, void** mark, void** arglast));
virtual int	do_spawn _((char *cmd));
virtual DIR*	opendir _((char *filename));
virtual int	closedir _((DIR *dirp));
virtual int ioctl _((int i, unsigned int u, char *data));

virtual void Exit _((int));
virtual void FlushAll _((void));
virtual int fprintf _((FILE *, const char *, ...));
virtual char *getlogin _((void));
virtual char*	NtGetLib _((void));
virtual char*	NtGetArchLib _((void));
virtual char*	NtGetSiteLib _((void));
virtual char*	NtGetBin _((void));
virtual char*	NtGetDebugScriptStr _((void));

CPerl(IPerlSupport *pvtbl);

void* operator new(size_t nSize, IPerlSupport *pvtbl);

virtual int& ErrorNo(void);
virtual void PerlCaller(char* string, int size);
virtual IPerlSupport* GetpVtbl(void);
virtual int IsWinNT(void);
virtual int IsWin95(void);
virtual void SaveTmps(void);
virtual void FreeTmps(void);
virtual void srand(unsigned int seed);
virtual int rand(void);
virtual CV* NewXSVersion(char *name, void (*subaddr)(CPerl *pPerl, CV* cv), char *filename, char *buildNum = NT_BUILD_NUMBER);
virtual char* NtCrypt _((char*pText, char*pSalt));
virtual SV* CreatePerlOLEObject _((long pDispatch));
virtual int NtIsSocket( int );

#endif /* MSWIN32 */
#endif /* PERL_OBJECT */

#endif	/* ___perl_proto_h___ */

