// sys/socket.h

// Douglas_Lankshear@ActiveWare.com
// Provide UNIX compatibility


#ifndef  _INC_SYS_SOCKET
#define  _INC_SYS_SOCKET


#ifndef  _WINDOWS_
#define  _WINDOWS_

#define  FAR
#define  PASCAL     __stdcall
#define  WINAPI     __stdcall

#undef WORD
typedef  int		BOOL;
typedef  unsigned short WORD;
typedef  void*		HANDLE;
typedef  void*		HWND;
typedef  int (FAR WINAPI *FARPROC)();

typedef unsigned long	DWORD;
typedef DWORD*			LPDWORD;
typedef void			VOID;
typedef void*			PVOID;
typedef int*			LPINT;

#define IN
#define OUT

typedef struct _OVERLAPPED {
    DWORD   Internal;
    DWORD   InternalHigh;
    DWORD   Offset;
    DWORD   OffsetHigh;
    HANDLE  hEvent;
} OVERLAPPED, *LPOVERLAPPED;

#endif //_WINDOWS_


#include <winsock.h>

#define  ENOTSOCK	WSAENOTSOCK
#undef   HOST_NOT_FOUND

#define htonl		nt_htonl
#define htons		nt_htons
#define ntohl		nt_ntohl
#define ntohs		nt_ntohs

#define socket		nt_socket
#define bind		nt_bind
#define listen		nt_listen
#define accept		nt_accept
#define connect		nt_connect
#define send		nt_send
#define sendto		nt_sendto
#define recv		nt_recv
#define recvfrom	nt_recvfrom
#define shutdown	nt_shutdown
#define ioctlsocket	nt_ioctlsocket
#define setsockopt	nt_setsockopt
#define getsockopt	nt_getsockopt
#define getpeername	nt_getpeername
#define getsockname	nt_getsockname
#define gethostname	nt_gethostname
#define gethostbyname	nt_gethostbyname
#define gethostbyaddr	nt_gethostbyaddr
#define getprotobyname	nt_getprotobyname
#define getprotobynumber nt_getprotobynumber
#define getservbyname	nt_getservbyname
#define getservbyport	nt_getservbyport
#define select		nt_select

#endif	// _INC_SYS_SOCKET
