

#ifndef __Inc__PerlLib__
#define __Inc__PerlLib__

#include "IPerlSup.h"

#ifdef __cplusplus
extern "C" {
#endif	// __cplusplus

//typedef struct _tagPerlHandle
//{
//	int unused;
//} *PerlHandle;

#define PERLLIBAPI __cdecl

CPerl* PERLLIBAPI CreateCPerl(IPerlSupport *pvtbl, IPerlSupport **pdllvtbl);
// return a pointer to a CPerl object - pointer is NULL if fails
// fills *pdllvtbl with a dll library interface
// pvtbl and pdllvtbl cannot be NULL


//PerlHandle PERLLIBAPI PerlCreate(IPerlSupport *pvtbl, IPerlSupport **pdllvtbl);
// creates a perl object and returns a handle NULL is fails
// fills *pdllvtbl with a dll library interface
// pvtbl and pdllvtbl cannot be NULL

//int PERLLIBAPI PerlParse(PerlHandle hPerl, int argc, char** argv, char** env);
// if env is NULL or *env is NULL then the current environment is used
// error if return is non zero

//int PERLLIBAPI PerlRun(PerlHandle hPerl);
// run the script that was parsed by PerlParse
// error if return is non zero

//void PERLLIBAPI PerlDestroy(PerlHandle hPerl);
// releases the memory allocated by PerlCreate, PerlParse, and PerlRun

int PERLLIBAPI PerlGetVersion(void);
// returns the build number of the dll

#ifdef __cplusplus
}
#endif	// __cplusplus


#endif	/* __Inc__PerlLib__ */
